﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using System.Runtime.InteropServices;

namespace PoKeysExamplesProject_cs
{
    public partial class Form1 : Form
    {
        PoKeysDevice_DLL.PoKeysDevice MyDevice = new PoKeysDevice_DLL.PoKeysDevice();
        

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void button1_Click(object sender, EventArgs e)
        {
            // Enumerate and list USB devices
            int i = MyDevice.EnumerateDevices();
            byte userID = 0;
            lstUSBdevices.Items.Clear();

            if (i > 0)
            {
                lstUSBdevices.Enabled = true;
                lstUSBdevices.Items.Clear();
                cmdConnectUSB.Enabled = true;
            }
            else
            {
                lstUSBdevices.Enabled = false;
                cmdConnectUSB.Enabled = false;
                lstUSBdevices.Items.Clear();
                lstUSBdevices.Items.Add("No device detected");
            }

            for (int k = 0; k < i; k++)
            {
                MyDevice.ConnectToDevice(k);

                MyDevice.GetUserID(ref userID);
                lstUSBdevices.Items.Add(MyDevice.GetDeviceTypeName() + " (" + userID + ")");

                MyDevice.DisconnectDevice();
            }

        }

        private void button2_Click(object sender, EventArgs e)
        {
            // Enumerate and list ethernet devices
            MyDevice.StartEthernetDiscovery();
            byte userID = 0;

            lstEthDevices.Items.Clear();
            lstEthDevices.Items.Add("Searching....");
            lstEthDevices.Enabled = false;
            lstEthDevices.Refresh();
            Application.DoEvents();
            Thread.Sleep(2000);

            MyDevice.StopEthernetDiscovery();

            if (MyDevice.GetNumberOfDetectedNetworkDevices() > 0)
            {
                lstEthDevices.Enabled = true;
                lstEthDevices.Items.Clear();
                cmdEthConnect.Enabled = true;
            }
            else
            {
                lstEthDevices.Items.Clear();
                lstEthDevices.Items.Add("No device detected");
                cmdEthConnect.Enabled = false;
            }
            for (int k = 0; k < MyDevice.GetNumberOfDetectedNetworkDevices(); k++)
            {
                // Three possibilites to connect to network device...

                MyDevice.ConnectToNetworkDevice(MyDevice.EthDeviceIP[k]);

                // Also
                //MyDevice.ConnectToNetworkDevice(MyDevice.GetNetworkDeviceAddress(k));

                // or even (with pointers)
                //PoKeysDevice_DLL.sPoKeysNetworkDeviceData netData = new PoKeysDevice_DLL.sPoKeysNetworkDeviceData();
                //IntPtr ptr =  Marshal.AllocHGlobal(200);
                //Marshal.StructureToPtr(netData, ptr, false);

                //MyDevice.COM_GetNetworkDeviceData(ptr, 0);

                //netData = (PoKeysDevice_DLL.sPoKeysNetworkDeviceData)Marshal.PtrToStructure(ptr, typeof(PoKeysDevice_DLL.sPoKeysNetworkDeviceData));
                //MyDevice.ConnectToNetworkDevice(netData.IPAddress);




                MyDevice.GetUserID(ref userID);
                lstEthDevices.Items.Add(MyDevice.GetDeviceTypeName() + " (" + userID + ")");

                MyDevice.DisconnectDevice();
            }
        }

        private void cmdConnectUSB_Click(object sender, EventArgs e)
        {
            if (lstUSBdevices.SelectedIndex >= 0)
            {
                bool success = MyDevice.ConnectToDevice(lstUSBdevices.SelectedIndex);

                if (success)
                {
                    cmdConnectUSB.Enabled = false;
                    cmdEnumerateUSB.Enabled = false;
                    cmdEthConnect.Enabled = false;
                    cmdEthEnumerate.Enabled = false;
                    cmdCustomConnect.Enabled = false;
                    lstUSBdevices.Enabled = false;
                    lstEthDevices.Enabled = false;
                    lblStatus.Text = "Status: Connected";
                    cmdDisconnect.Enabled = true;
                }
            }
        }

        private void cmdEthConnect_Click(object sender, EventArgs e)
        {
            if (lstEthDevices.SelectedIndex >= 0)
            {
                bool success = MyDevice.ConnectToNetworkDevice(MyDevice.EthDeviceIP[lstEthDevices.SelectedIndex]);

                if (success)
                {
                    cmdConnectUSB.Enabled = false;
                    cmdEnumerateUSB.Enabled = false;
                    cmdEthConnect.Enabled = false;
                    cmdEthEnumerate.Enabled = false;
                    cmdCustomConnect.Enabled = false;
                    lstUSBdevices.Enabled = false;
                    lstEthDevices.Enabled = false;
                    tmrEthPing.Enabled = true;
                    lblStatus.Text = "Status: Connected";
                    cmdDisconnect.Enabled = true;
                }
            }
        }

        private void cmdCustomConnect_Click(object sender, EventArgs e)
        {
            bool success = MyDevice.ConnectToNetworkDevice(textBox1.Text);

            if (success)
            {
                cmdConnectUSB.Enabled = false;
                cmdEnumerateUSB.Enabled = false;
                cmdEthConnect.Enabled = false;
                cmdEthEnumerate.Enabled = false;
                cmdCustomConnect.Enabled = false;
                lstUSBdevices.Enabled = false;
                lstEthDevices.Enabled = false;
                tmrEthPing.Enabled = true;
                lblStatus.Text = "Status: Connected";
                cmdDisconnect.Enabled = true;
            }
        }

        private void tmrEthPing_Tick(object sender, EventArgs e)
        {
            // Just ping the device every 1 second
            uint counter = 0;
            MyDevice.GetTickCounter(ref counter);
        }

        private void button1_Click_1(object sender, EventArgs e)
        {
            cmdEnumerateUSB.Enabled = true;
            cmdEthEnumerate.Enabled = true;
            cmdCustomConnect.Enabled = true;

            lstUSBdevices.Enabled = true;
            lstEthDevices.Enabled = true;
            tmrEthPing.Enabled = false;
            lblStatus.Text = "Status: Disconnected";

        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (MyDevice.Connected()) MyDevice.DisconnectDevice();
            this.Close();
        }

        private void setPinAsInputToolStripMenuItem_Click(object sender, EventArgs e)
        {
            // Set pin 1 (with index 0) as digital input
            MyDevice.SetPinData(0, (byte)PoKeysDevice_DLL.ePinCap.digitalInput);
        }

        private void setPinAsInvertedDigitalInputToolStripMenuItem_Click(object sender, EventArgs e)
        {
            // Set pin 1 (with index 0) as inverted digital input (bit 7 set)
            MyDevice.SetPinData(0, (byte)PoKeysDevice_DLL.ePinCap.digitalInput | (1 << 7));
        }

        private void readPinStateToolStripMenuItem_Click(object sender, EventArgs e)
        {
            bool pinState = false;

            MyDevice.GetInput(0, ref pinState);

            MessageBox.Show("Pin 0: " + (pinState ? "ON" : "OFF"));
        }

        

        private void setPinAsAnalogInputToolStripMenuItem_Click(object sender, EventArgs e)
        {
            // Set pin 43 as analog input
            MyDevice.SetPinData(42, (byte)PoKeysDevice_DLL.ePinCap.analogInput);
        }

        private void readAnalogValueToolStripMenuItem_Click(object sender, EventArgs e)
        {
            // Read analog value
            int value = 0;
            MyDevice.GetAnalogInput(42, ref value);
            
            MessageBox.Show("Analog value: " + (3.3 * (double)value / MyDevice.GetAnalogValueMax()).ToString("0.00") + " V");
        }

        private void setPinAsDigitalOutputToolStripMenuItem_Click(object sender, EventArgs e)
        {
            // Set pin 2 (with index 1) as digital output
            MyDevice.SetPinData(1, (byte)PoKeysDevice_DLL.ePinCap.digitalOutput);
        }

        private void setPin2ToONToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MyDevice.SetOutput(1, true);
        }

        private void setPin2ToOFFToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MyDevice.SetOutput(1, false);
        }

        private void readTickCounterToolStripMenuItem_Click(object sender, EventArgs e)
        {
            uint ticks = 0;

            MyDevice.GetTickCounter(ref ticks);

            MessageBox.Show("Tick counter: " + ticks);
        }

        private void setPinXAsPWMOutputToolStripMenuItem_Click(object sender, EventArgs e)
        {
            bool[] channel = new bool[6];
            uint[] duty = new uint[6];

            // PWM base clock is 12 MHz (or 25 MHz on PoKeys56 devices), so 1 ms takes 12000 (25000) cycles
            float ms = MyDevice.GetPWMFrequency() / 1000;
            uint period = (uint)(ms * 20);   // 20 ms period

            channel[5] = true; // Pin 17 = channel 5 (Pin 18 = channel 4, ...)
            duty[5] = (uint)(ms * 1.5); // Set duty cycle to 1.5 ms (7.5 %)

            MyDevice.SetPWMOutputs(ref channel, ref period, ref duty);
        }

        private void setupMatrixKeyboardToolStripMenuItem_Click(object sender, EventArgs e)
        {
byte[] rows = new byte[16]; // This must always be the size of 16
byte[] cols = new byte[8];  // This must always be the size of 8

bool[] macros = new bool[128];      // This must always be the size of 128
byte[] keys = new byte[128];         // This must always be the size of 128
byte[] modifiers = new byte[128];    // This must always be the size of 128

for (int i=0; i<4; i++)
{
    cols[i] = (byte)i;
    rows[i] = (byte)(i+4);
}

byte configuration = 1;
byte numrows = 4;
byte numcols = 4;

// Set column pins as digital inputs
MyDevice.SetPinData(0, 1 << 1);
MyDevice.SetPinData(1, 1 << 1);
MyDevice.SetPinData(2, 1 << 1);
MyDevice.SetPinData(3, 1 << 1);

// Set row pins as digital outputs
MyDevice.SetPinData(4, 1 << 2);
MyDevice.SetPinData(5, 1 << 2);
MyDevice.SetPinData(6, 1 << 2);
MyDevice.SetPinData(7, 1 << 2);

MyDevice.SetMatrixKeyboardConfiguration(ref configuration, ref numcols, ref numrows, ref rows, ref cols, ref macros, ref keys, ref modifiers);
        }

        private void readStatusToolStripMenuItem_Click(object sender, EventArgs e)
        {
            bool[] KeyStates = new bool[128];

            MyDevice.GetMatrixKeyboardKeyStatus(ref KeyStates);

            string status = "";
            for (int row = 0; row < 4; row++)
            {
                for (int col = 0; col < 4; col++)
                {
                    status += KeyStates[row * 8 + col] ? "1 " : "0 ";
                }
                status += "\n";
            }

            MessageBox.Show("Key statuses:\n" + status);
        }

        private void writeDataToFirstPoExtBusDeviceToolStripMenuItem_Click(object sender, EventArgs e)
        {
            byte[] dataOut = new byte[10];

            // Set some value
            dataOut[9] = 0xAA;

            MyDevice.AuxilaryBusSetData(1, dataOut);
        }

        private void readTemperatureFrom1wireDS18B20TemperatureSensorOnPin55ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            byte stat = 0;
            byte[] data = new byte[16];

            MyDevice.prot1WireSetStatus(true);

            data[0] = 0xCC;
            data[1] = 0x44;
            MyDevice.prot1WireStartWriteAndRead(2, 0, data);

            Thread.Sleep(1000);

            data[0] = 0xCC;
            data[1] = 0xBE;
            MyDevice.prot1WireStartWriteAndRead(2, 9, data);

            Thread.Sleep(10);

            byte len = 0;
            MyDevice.prot1WireGetReadStatus(ref stat, ref data, ref len);

            if (stat == 1)
            {
                MessageBox.Show("Temperature: " + (((data[1] << 8) + data[0]) >> 4) + "°C");
            }
            else
            {
                MessageBox.Show("Error reading");
            }
        }

        private void readTemperatureFromI2CML75SensorOnPoExtBusToolStripMenuItem_Click(object sender, EventArgs e)
        {
            byte stat = 0;
            byte[] data = new byte[32];

            // Turn off PoExtBus
            MyDevice.AuxilaryBusSetData(0, data);

            // Activate I2C
            MyDevice.I2CSetStatus(true);

            // Write 0 to the device (set address)
            data[0] = 0;
            MyDevice.I2CStartWrite(0x48, 1, data);
            Thread.Sleep(10);
            MyDevice.I2CGetWriteStatus(ref stat);

            if (stat != 1)
            {
                MessageBox.Show("Error writing (" + stat + ")");
                return;
            }

            // Read temperature
            MyDevice.I2CStartRead(0x48, 2);
            Thread.Sleep(10);
            MyDevice.I2CGetReadStatus(ref stat, ref data);

            if (stat == 1)
            {
                MessageBox.Show("Temperature: " + data[0] + "°C");
            }
            else
            {
                MessageBox.Show("Error reading");
            }

            // Deactivate I2C
            MyDevice.I2CSetStatus(false);
        }

        private void activateMatrixLED1ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            // Enable LED1
            MyDevice.MatrixLEDSetSettings(true, 8, 8, false, 8, 8);

            // Invert the whole matrix
            MyDevice.MatrixLED1ClearAll(true);

            // Draw a dark + sign
            MyDevice.MatrixLED1SetPixel(2, 1, false);
            MyDevice.MatrixLED1SetPixel(1, 1, false);
            MyDevice.MatrixLED1SetPixel(0, 1, false);
            MyDevice.MatrixLED1SetPixel(1, 0, false);
            MyDevice.MatrixLED1SetPixel(1, 2, false);
        }

        private void activateLCDOnPrimaryPinsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            // Setup LCD connected to primary pins
            MyDevice.LCDSetSettings(1, 4, 20);

            // Initialize LCD module
            MyDevice.LCDInit();
            Thread.Sleep(10);

            // Clear LCD
            MyDevice.LCDClear();

            // Print text in the second line
            MyDevice.LCDGotoXY(0, 1);
            MyDevice.LCDPrint("PoKeys56E LCD test");

        }

        private void enableFastEncodersToolStripMenuItem_Click(object sender, EventArgs e)
        {
            // Use configuration 2 (value 10) and index signals that reset the encoder values
            MyDevice.SetFastEncodersStatusWOptions(10, 1);
        }

        private void readEncoder1ValueToolStripMenuItem_Click(object sender, EventArgs e)
        {
            int value = 0;
            MyDevice.GetEncoderRAWValue(0, ref value);

            MessageBox.Show("Encoder 1 value: " + value);
        }

        private void readTemperatureAndHumidityFromI2CSHT21SensorToolStripMenuItem_Click(object sender, EventArgs e)
        {
            byte stat = 0;
            byte[] data = new byte[32];

            // Write 0xF3 to the device (start measurement)
            data[0] = 0xF3;
            MyDevice.I2CStartWrite(0x40, 1, data);
            Thread.Sleep(100);
            MyDevice.I2CGetWriteStatus(ref stat);

            if (stat != 1)
            {
                MessageBox.Show("Error writing (" + stat + ")");
                return;
            }

            // Read temperature
            MyDevice.I2CStartRead(0x40, 3);
            Thread.Sleep(10);
            MyDevice.I2CGetReadStatus(ref stat, ref data);

            if (stat == 1)
            {
                double temp = 175.72 * (((double)data[0] * 256) + (double)(data[1] & 0xFC)) / 65536 - 46.85;

                MessageBox.Show("Temperature: " + temp.ToString("0.00") + "°C");
            }
            else
            {
                MessageBox.Show("Error reading");
            }


            // Write 0xF5 to the device (start measurement)
            data[0] = 0xF5;
            MyDevice.I2CStartWrite(0x40, 1, data);
            Thread.Sleep(100);
            MyDevice.I2CGetWriteStatus(ref stat);

            if (stat != 1)
            {
                MessageBox.Show("Error writing (" + stat + ")");
                return;
            }

            // Read temperature
            MyDevice.I2CStartRead(0x40, 3);
            Thread.Sleep(10);
            MyDevice.I2CGetReadStatus(ref stat, ref data);

            if (stat == 1)
            {
                double hum = 125 * (((double)data[0] * 256) + (double)(data[1] & 0xFC)) / 65536 - 6;

                MessageBox.Show("Humidity: " + hum.ToString("0.00") + "%");
            }
            else
            {
                MessageBox.Show("Error reading");
            }
        }
    }
}
