﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Example1_ConnectingToPoKeys55
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("PoKeys55 Example 1 - device enumeration\n");

            // Create PoKeys55 device object
            PoKeysDevice_DLL.PoKeysDevice device = new PoKeysDevice_DLL.PoKeysDevice();

            // Enumerate devices (this step must never be ommited!)
            int iNumDevices = device.EnumerateDevices();

            Console.WriteLine("Found " + iNumDevices + " PoKeys55 devices");


            // Connect to every device and list data
            for (int i = 0; i < iNumDevices; i++)
            {
                device.ConnectToDevice(i);

                byte userID = 0;
                int serialNumber = 0;
                int versionMajor = 0;
                int versionMinor = 0;

                device.GetUserID(ref userID);
                device.GetDeviceIDEx(ref serialNumber, ref versionMajor, ref versionMinor);

                Console.WriteLine("Device #" + i + ", UserID: " + userID + ", Serial number: " + serialNumber +
                    ", Version: " + (versionMajor / 16 + 1) + "." + (versionMajor % 16) + "." + versionMinor);

                device.DisconnectDevice();
            }


            Console.WriteLine("\nPress any key to exit");
            Console.ReadKey();
        }
    }
}
