﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Example1b_ConnectingToPoKeys56E
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("PoKeys56 Example 1 - device enumeration\n");

            // Create PoKeys55 device object
            PoKeysDevice_DLL.PoKeysDevice device = new PoKeysDevice_DLL.PoKeysDevice();

            string[] ipAddresses;
            bool automaticDiscovery = true;
            int iNumDevices;

            if (automaticDiscovery)
            {
                // Start automatic discovery of PoKeys56E devices
                device.StartEthernetDiscovery();

                // Wait 1 second for discovery to gather results
                System.Threading.Thread.Sleep(1000);

                // Stop automatic discovery
                device.StopEthernetDiscovery();

                // Get the number of detected network devices
                iNumDevices = device.GetNumberOfDetectedNetworkDevices();

                Console.WriteLine("\nFound " + iNumDevices + " PoKeys56E devices");

                ipAddresses = device.GetNetworkDevicesAddressses();
            }
            else
            {
                // Connect to PoKeys56E device with a known IP (for example 192.168.10.101
                iNumDevices = 1;
                ipAddresses = new string[1];
                ipAddresses[0] = "192.168.10.101";


                // You can also connect to the device directly... device.ConnectToNetworkDevice("192.168.10.101");
            }

            // Connect to every device and list data
            for (int i = 0; i < iNumDevices; i++)
            {
                device.ConnectToNetworkDevice(ipAddresses[i]);

                // From this point on, communication is identical for USB and ethernet PoKeys devices
                byte userID = 0;
                int serialNumber = 0;
                int versionMajor = 0;
                int versionMinor = 0;

                device.GetUserID(ref userID);
                device.GetDeviceIDEx(ref serialNumber, ref versionMajor, ref versionMinor);

                Console.WriteLine("\nDevice #" + i + ", UserID: " + userID + ", Serial number: " + serialNumber +
                    ", Version: " + (versionMajor / 16 + 1) + "." + (versionMajor % 16) + "." + versionMinor);

                device.DisconnectDevice();
            }


            Console.WriteLine("\nPress any key to exit");
            Console.ReadKey();
        }
    }
}
