﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Example2_BasicPinFunctions
{
    class Program
    {

        public enum pinFunctionsEnum
        {
            pinFunctionInactive = 0,
            pinFunctionDigitalInput = 2,
            pinFunctionDigitalOutput = 4,
            pinFunctionAnalogInput = 8,
            pinFunctionAnalogOutput = 16,
            pinInvert = 128
        }

        // Key modifiers
        public enum keyModifiers
        {
            CtrlMask = 1,
            ShiftMask = 2,
            AltMask = 4,
            WinMask = 8,
            AltGrMask = 64
        }

        // Key codes
        public enum ekeyCodes
        {
            key_a = 0x4, // Shift combination: A
            key_b = 0x5, // Shift combination: B
            key_c = 0x6, // Shift combination: C
            key_d = 0x7, // Shift combination: D
            key_e = 0x8, // Shift combination: E
            key_f = 0x9, // Shift combination: F
            key_g = 0x0A, // Shift combination: G
            key_h = 0x0B, // Shift combination: H
            key_i = 0x0C, // Shift combination: I
            key_j = 0x0D, // Shift combination: J
            key_k = 0x0E, // Shift combination: K
            key_l = 0x0F, // Shift combination: L
            key_m = 0x10, // Shift combination: M
            key_n = 0x11, // Shift combination: N
            key_o = 0x12, // Shift combination: O
            key_p = 0x13, // Shift combination: P
            key_q = 0x14, // Shift combination: Q
            key_r = 0x15, // Shift combination: R
            key_s = 0x16, // Shift combination: S
            key_t = 0x17, // Shift combination: T
            key_u = 0x18, // Shift combination: U
            key_v = 0x19, // Shift combination: V
            key_w = 0x1A, // Shift combination: W
            key_x = 0x1B, // Shift combination: X
            key_y = 0x1C, // Shift combination: Y
            key_z = 0x1D, // Shift combination: Z
            key_1 = 0x1E, // Shift combination: !
            key_2 = 0x1F, // Shift combination: @
            key_3 = 0x20, // Shift combination: #
            key_4 = 0x21, // Shift combination: $
            key_5 = 0x22, // Shift combination: %
            key_6 = 0x23, // Shift combination: ^
            key_7 = 0x24, // Shift combination: &
            key_8 = 0x25, // Shift combination: *
            key_9 = 0x26, // Shift combination: (
            key_0 = 0x27, // Shift combination: )
            key_Minus = 0x2D, // Shift combination: _
            key_Equal = 0x2E, // Shift combination: +
            key_SquareOpeningBracket = 0x2F, // Shift combination: {
            key_SquareClosingBracket = 0x30, // Shift combination: }
            key_BackSlash = 0x31, // Shift combination: |
            key_Semicolon = 0x33, // Shift combination: :
            key_Apostrophe = 0x34, // Shift combination: 
            key_Tilde = 0x35, // Shift combination: ~
            key_Comma = 0x36, // Shift combination: <
            key_FullStop = 0x37, // Shift combination: >
            key_Slash = 0x38, // Shift combination: ?
            key_Return = 0x28, // Shift combination: 
            key_Escape = 0x29, // Shift combination: 
            key_Backspace = 0x2A, // Shift combination: 
            key_Tab = 0x2B, // Shift combination: 
            key_Space = 0x2C, // Shift combination: 
            key_CapsLock = 0x39, // Shift combination: 
            key_F1 = 0x3A, // Shift combination: 
            key_F2 = 0x3B, // Shift combination: 
            key_F3 = 0x3C, // Shift combination: 
            key_F4 = 0x3D, // Shift combination: 
            key_F5 = 0x3E, // Shift combination: 
            key_F6 = 0x3F, // Shift combination: 
            key_F7 = 0x40, // Shift combination: 
            key_F8 = 0x41, // Shift combination: 
            key_F9 = 0x42, // Shift combination: 
            key_F10 = 0x43, // Shift combination: 
            key_F11 = 0x44, // Shift combination: 
            key_F12 = 0x45, // Shift combination: 
            key_PrintScreen = 0x46, // Shift combination: 
            key_ScrollLock = 0x47, // Shift combination: 
            key_Insert = 0x49, // Shift combination: 
            key_Home = 0x4A, // Shift combination: 
            key_PageUp = 0x4B, // Shift combination: 
            key_Delete = 0x4C, // Shift combination: 
            key_End = 0x4D, // Shift combination: 
            key_PageDown = 0x4E, // Shift combination: 
            key_RightArrow = 0x4F, // Shift combination: 
            key_LeftArrow = 0x50, // Shift combination: 
            key_DownArrow = 0x51, // Shift combination: 
            key_UpArrow = 0x52, // Shift combination: 
            key_NumLock = 0x53, // Shift combination: 
            key_KeypadDivide = 0x54, // Shift combination: 
            key_KeypadMultiply = 0x55, // Shift combination: 
            key_KeypadMinus = 0x56, // Shift combination: 
            key_KeypadPlus = 0x57, // Shift combination: 
            key_KeypadEnter = 0x58, // Shift combination: 
            key_Keypad1 = 0x59, // Shift combination: 
            key_Keypad2 = 0x5A, // Shift combination: 
            key_Keypad3 = 0x5B, // Shift combination: 
            key_Keypad4 = 0x5C, // Shift combination: 
            key_Keypad5 = 0x5D, // Shift combination: 
            key_Keypad6 = 0x5E, // Shift combination: 
            key_Keypad7 = 0x5F, // Shift combination: 
            key_Keypad8 = 0x60, // Shift combination: 
            key_Keypad9 = 0x61, // Shift combination: 
            key_Keypad0 = 0x62, // Shift combination: 
            key_KeypadDot = 0x63 // Shift combination: 
        }

        static void Main(string[] args)
        {
            Console.WriteLine("PoKeys55 Example 2 - basic pin functions\n");

            // Create PoKeys55 device object
            PoKeysDevice_DLL.PoKeysDevice device = new PoKeysDevice_DLL.PoKeysDevice();

            // Enumerate devices (this step must never be ommited!)
            int iNumDevices = device.EnumerateDevices();

            if (iNumDevices == 0) 
            {
                Console.WriteLine("No PoKeys55 devices found!");

                
                Console.WriteLine("\nPress any key to exit");
                Console.ReadKey();
                return;
            }

            // Connect to first PoKeys55 device
            device.ConnectToDevice(0);

            
            // Set pin 1 as digital input (pin 1 has pin index 0!)
            device.SetPinData(0, (byte)(pinFunctionsEnum.pinFunctionDigitalInput));
            Console.WriteLine("Pin 1 was set as digital input");

            // Set pin 2 as inverted digital input
            device.SetPinData(1, (byte)(pinFunctionsEnum.pinFunctionDigitalInput) + (byte)(pinFunctionsEnum.pinInvert));
            Console.WriteLine("Pin 2 was set as inverted digital input");

            // Set pin 3 as digital output
            device.SetPinData(2, (byte)(pinFunctionsEnum.pinFunctionDigitalOutput));
            Console.WriteLine("Pin 3 was set as digital output");

            // Set pin 4 as inverted digital output
            device.SetPinData(3, (byte)(pinFunctionsEnum.pinFunctionDigitalOutput) + (byte)(pinFunctionsEnum.pinInvert));
            Console.WriteLine("Pin 4 was set as inverted digital output");

            // Set pin 5 as digital input directly mapped to a key shift+A
            device.SetPinData(4, (byte)(pinFunctionsEnum.pinFunctionDigitalInput) + (byte)(pinFunctionsEnum.pinInvert));
            device.SetPinKeyMapping(4, (byte)ekeyCodes.key_a, (byte)keyModifiers.ShiftMask);

            Console.WriteLine("\nReading pin states:");

            bool pinState = false;

            // Get pin 1 state
            device.GetInput(0, ref pinState);
            Console.WriteLine("Pin 1: " + pinState.ToString());

            // Get pin 2 state
            device.GetInput(1, ref pinState);
            Console.WriteLine("Pin 2: " + pinState.ToString());


            Console.WriteLine("\nSetting pin states:");
            
            // Set pin 3 state to 1
            device.SetOutput(2, true);
            Console.WriteLine("Pin 3 set to 1");

            // Set pin 4 state to 0
            device.SetOutput(3, false);
            Console.WriteLine("Pin 4 set to 0");

            // Disconnect from device
            device.DisconnectDevice();

            Console.WriteLine("\nPress any key to exit");
            Console.ReadKey();

        }
    }
}
