﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Example4_AnalogOutput
{
    class Program
    {
        public enum pinFunctionsEnum
        {
            pinFunctionInactive = 0,
            pinFunctionDigitalInput = 2,
            pinFunctionDigitalOutput = 4,
            pinFunctionAnalogInput = 8,
            pinFunctionAnalogOutput = 16,
            pinInvert = 128
        }


        static void Main(string[] args)
        {
            Console.WriteLine("PoKeys55 Example 4 - analog output\n");

            // Create PoKeys55 device object
            PoKeysDevice_DLL.PoKeysDevice device = new PoKeysDevice_DLL.PoKeysDevice();

            // Enumerate devices (this step must never be ommited!)
            int iNumDevices = device.EnumerateDevices();

            if (iNumDevices == 0)
            {
                Console.WriteLine("No PoKeys55 devices found!");


                Console.WriteLine("\nPress any key to exit");
                Console.ReadKey();
                return;
            }

            // Connect to first PoKeys55 device
            device.ConnectToDevice(0);


            // Set pin 43 as analog output
            device.SetPinData(42, (byte)(pinFunctionsEnum.pinFunctionAnalogOutput));
            Console.WriteLine("Pin 43 was set as analog output");


            double analogOutputVoltage = 2; // 2.00 V

            // Set analog output value
            device.SetAnalogOutputValue(42, (int)(analogOutputVoltage / 3.3 * 1023));
            Console.WriteLine("\nAnalog output voltage set to " + analogOutputVoltage.ToString("0.00") + " V");

            device.DisconnectDevice();

            Console.WriteLine("\nPress any key to exit");
            Console.ReadKey();

        }
    }
}
