﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Example8_MatrixLED
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("PoKeys55 Example 8 - matrix LED usage\n");

            // Create PoKeys55 device object
            PoKeysDevice_DLL.PoKeysDevice device = new PoKeysDevice_DLL.PoKeysDevice();

            // Enumerate devices (this step must never be ommited!)
            int iNumDevices = device.EnumerateDevices();

            if (iNumDevices == 0)
            {
                Console.WriteLine("No PoKeys55 devices found!");


                Console.WriteLine("\nPress any key to exit");
                Console.ReadKey();
                return;
            }

            // Connect to first PoKeys55 device
            device.ConnectToDevice(0);


            // Connect matrix LED display accordingly to the schematics found in PoKeys55 user manual
            // Use this pin mapping:
            //   - pin 9 as serial data
            //   - pin 10 as shift register latch clock
            //   - pin 11 as serial clock

            // Use only display 1
            device.MatrixLEDSetSettings(true, 5, 5, false, 0, 0);

            // Fill the display pixel by pixel
            device.MatrixLED1ClearAll(false);

            for (byte y = 0; y < 5; y++)
            {
                for (byte x = 0; x < 5; x++)
                {
                    device.MatrixLED1SetPixel(y, x, true);

                    System.Threading.Thread.Sleep(20);
                }
            }

            // Then clear the whole display pixel by pixel
            for (byte y = 0; y < 5; y++)
            {
                for (byte x = 0; x < 5; x++)
                {
                    device.MatrixLED1SetPixel(y, x, false);

                    System.Threading.Thread.Sleep(20);
                }
            }
            
            // Update display with some data (increasing bars)
            // these bytes are pixel mapped
            // displayBuffer[0].0 (first bit in first byte) represents first pixel on the display
            byte[] displayBuffer = new byte[8];
            displayBuffer[0] = 1;
            displayBuffer[1] = 3;
            displayBuffer[2] = 7;
            displayBuffer[3] = 15;
            displayBuffer[4] = 31;
            displayBuffer[5] = 0;
            displayBuffer[6] = 0;
            displayBuffer[7] = 0;

            device.MatrixLED1Update(displayBuffer);


            device.DisconnectDevice();

            Console.WriteLine("\nPress any key to exit");
            Console.ReadKey();
        }
    }
}
