// Example1_ConnectingToPoKeys55.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>

// Import TLB file - this must be the same version as the DLL
#import "..\PoKeysDevice_DLL.tlb"  no_namespace



int _tmain(int argc, _TCHAR* argv[])
{
	BSTR builddate = SysAllocString(L"");

	printf("---------------------------------");
	printf("\nTesting PoKeys device - DLL\n");
	printf("---------------------------------");

	try
	{
		// Initialize COM 
		CoInitialize(NULL);

		long st = 0;
		unsigned char id = 0;
		int i;

		// PoKeys device pointer
		IPoKeysDevicePtr ptr;
		// Create instance of the device
		ptr.CreateInstance(__uuidof(PoKeysDevice));

		if (ptr == 0)
		{
			printf("\nCOM initialization failed - check if TLB has the same version as the DLL");
			getchar();
			return 1;
		}

		// From here on, PoKeys can simply be used by refering to the ptr

		// Enumerate devices
		i = ptr->EnumerateDevices();

		if (i > 0)
		{
			// Connect to first device
			ptr->ConnectToDevice(0);

			// This call retrieves the current device status
			sPoKeysDeviceStatus * devStat = new sPoKeysDeviceStatus();

			// PoKeys device data structure is filled with the configuration
			ptr->COM_Execute((int)devStat, (int)(ePoKeysDLLOperations_GetDeviceData));
			ptr->COM_Execute((int)devStat, (int)(ePoKeysDLLOperations_GetPinConfiguration));
			ptr->COM_Execute((int)devStat, (int)(ePoKeysDLLOperations_GetPeripheralConfiguration));

			DWORD end = GetTickCount();

			// Disconnect from device
			ptr->DisconnectDevice();

			// Print data
			printf("\nUser ID: %d", devStat->DeviceData.UserID);
			printf("\nSerial number: %d", devStat->DeviceData.SerialNumber);
			printf("\nBuild date: %s", devStat->DeviceData.BuildDate);
		} else
		{
			printf("\nNo PoKeys devices found!");
		}
	}
	catch( char * str ) {
		printf("Exception raised: %s", str);
	}

	// Unitialize COM
	CoUninitialize();

	printf("\n\nTest complete");

	getchar();
	return 0;


	return 0;
}

