// PoKeysNativeCpp.cpp : Defines the entry point for the console application.
//

#include "windows.h"
#include "conio.h"
#include "stdio.h"
#include "string.h"
#include "PoKeysLib.h"

// List of detected PoKeys devices
sPoKeysDevice PoKeysDevices[16];

int main(int argc, char *argv[])
{
	// Initialize Winsock
    if (InitWinsock() != 0) return -1;

	// Enumerate PoKeys devices
	int numDevices = EnumeratePoKeysDevices(PoKeysDevices);

	if (numDevices == 0)
	{
		printf("No PoKeys devices found!\n");
		TerminateWinsock();
		return 0;
	}
	
	// Connect to first PoKeys device
	if (ConnectToPoKeysDevice(&PoKeysDevices[0]) != 0)
	{
		printf("Could not connect to PoKeys board!\n");
		TerminateWinsock();
		return 0;
	}
	
	// Create PoKeys device structure
	sPoKeysDeviceStatus deviceStat;

	// Fill the device info structure
	GetDeviceData(&deviceStat);

	// Clear all digital outputs
	for (int i = 0; i < 55; i++) deviceStat.Pins[i].DigitalOutputValue = 0;

	// Set pins 1 to 10 as outputs
	for (int i = 0; i < 55; i++) 
		if (i < 10) deviceStat.Pins[i].PinFunction = pinFunctionDigitalOutput;
		else deviceStat.Pins[i].PinFunction = pinFunctionInactive;

	// Set pin directions (this must be called on every device startup since outputs are not activated before!)
	SetPinFunctions(&deviceStat);

	// Set the outputs 0 and 2 to 1
	deviceStat.Pins[0].DigitalOutputValue = 1;
	deviceStat.Pins[2].DigitalOutputValue = 1;
	SetDigitalOutputsStatus(&deviceStat); // Sets the outputs and reads the inputs
	//GetDigitalInputsStatus(&deviceStat); // Set output command above also reads the current inputs


	// If socket is left open for longer, keep the connection open by 'pinging' the PoKeys device with data at lease once every second.

	DisconnectPoKeysDevice();

    TerminateWinsock(); //Clean up Winsock
	
	getchar();
	return 0;
 
}