program Example1_ConnectingToPoKeys55;

{$APPTYPE CONSOLE}

uses
  SysUtils, PoKeysDevice_DLL_TLB;

var
  device: TPoKeysDevice;
  iNumDevices, i: Integer;
  userID: Byte;
  serialNumber, versionMajor, versionMinor: Integer;
  v1,v2,v3: Integer;
begin
  try

    // Create PoKeys55 device object
    device := TPoKeysDevice.Create(nil);
    device.Connect;

    // Enumerate devices (this step must never be ommited!)
    iNumDevices := device.EnumerateDevices();

    Writeln('Found ' + IntToStr(iNumDevices) + ' PoKeys55 devices');


    // Connect to every device and list data
    for i:= 0 to iNumDevices-1 do
    begin
        device.ConnectToDevice(i);

        device.GetUserID(userID);
        device.GetDeviceIDEx(serialNumber, versionMajor, versionMinor);

        v1 := versionMajor div 16 + 1;
        v2 := versionMajor mod 16;

        Writeln('Device #' + IntToStr(i) + ', UserID: ' + IntToStr(userID) + ', Serial number: ' +
              IntToStr(serialNumber) + ', Version: ' + IntToStr(v1) + '.' +
              IntToStr(v2) + '.' + IntToStr(versionMinor));

        device.DisconnectDevice();
    end;


    Writeln(#13#10 + 'Press enter key to exit');
    Readln;


    device.Disconnect();
    device.Destroy;

  except
    on E: Exception do
      Writeln(E.ClassName, ': ', E.Message);
  end;
end.
