program Example1b_ConnectingToPoKeys56E;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  PoKeysDevice_DLL_TLB;

var
  device: TPoKeysDevice;
  iNumDevices, i: Integer;
  userID: Byte;
  serialNumber, versionMajor, versionMinor: Integer;
  v1,v2,v3: Integer;
begin
  try

    // Create PoKeys55 device object
    device := TPoKeysDevice.Create(nil);
    device.Connect;

    // Start automatic discovery of PoKeys56E devices
    device.StartEthernetDiscovery();

    // Wait 1 second for discovery to gather results
    Sleep(1000);

    // Stop automatic discovery
    device.StopEthernetDiscovery();

    // Get the number of detected network devices
    iNumDevices := device.GetNumberOfDetectedNetworkDevices();


    // Connect to every device and list data
    for i:= 0 to iNumDevices-1 do
    begin
      device.ConnectToNetworkDevice(device.GetNetworkDeviceAddress(i));

      device.GetUserID(userID);
      device.GetDeviceIDEx(serialNumber, versionMajor, versionMinor);

      v1 := versionMajor div 16 + 1;
      v2 := versionMajor mod 16;

      Writeln('Device #' + IntToStr(i) + ', UserID: ' + IntToStr(userID) + ', Serial number: ' +
            IntToStr(serialNumber) + ', Version: ' + IntToStr(v1) + '.' +
            IntToStr(v2) + '.' + IntToStr(versionMinor));

      device.DisconnectDevice();
    end;






    // Connect to to a device with a predefined IP address
    device.ConnectToNetworkDevice('192.168.10.101');

    device.GetUserID(userID);
    device.GetDeviceIDEx(serialNumber, versionMajor, versionMinor);

    v1 := versionMajor div 16 + 1;
    v2 := versionMajor mod 16;

    Writeln('Device #' + IntToStr(i) + ', UserID: ' + IntToStr(userID) + ', Serial number: ' +
          IntToStr(serialNumber) + ', Version: ' + IntToStr(v1) + '.' +
          IntToStr(v2) + '.' + IntToStr(versionMinor));

    device.DisconnectDevice();



    Writeln(#13#10 + 'Press enter key to exit');
    Readln;


    device.Disconnect();
    device.Destroy;

  except
    on E: Exception do
      Writeln(E.ClassName, ': ', E.Message);
  end;
end.
