VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "PoKeys55 example"
   ClientHeight    =   3435
   ClientLeft      =   45
   ClientTop       =   345
   ClientWidth     =   4500
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3435
   ScaleWidth      =   4500
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer tmrRefresh 
      Enabled         =   0   'False
      Interval        =   100
      Left            =   4080
      Top             =   3000
   End
   Begin VB.Frame frOperations 
      Caption         =   "Operations"
      Enabled         =   0   'False
      Height          =   2175
      Left            =   120
      TabIndex        =   4
      Top             =   1080
      Width           =   4215
      Begin VB.HScrollBar hScrValue 
         Height          =   255
         LargeChange     =   100
         Left            =   240
         Max             =   1023
         TabIndex        =   9
         Top             =   1680
         Width           =   3735
      End
      Begin VB.PictureBox picValue 
         Appearance      =   0  'Flat
         BackColor       =   &H80000005&
         ForeColor       =   &H80000008&
         Height          =   255
         Left            =   240
         ScaleHeight     =   225
         ScaleWidth      =   3705
         TabIndex        =   7
         Top             =   840
         Width           =   3735
      End
      Begin VB.CommandButton cmdSetOutput 
         Caption         =   "Set pin 43 as analog output"
         Enabled         =   0   'False
         Height          =   375
         Left            =   240
         TabIndex        =   6
         Top             =   1200
         Width           =   2295
      End
      Begin VB.CommandButton cmdSetInput 
         Caption         =   "Set pin 44 as analog input"
         Enabled         =   0   'False
         Height          =   375
         Left            =   240
         TabIndex        =   5
         Top             =   360
         Width           =   2295
      End
      Begin VB.Label lblOutValue 
         Height          =   255
         Left            =   3480
         TabIndex        =   10
         Top             =   1320
         Width           =   495
      End
      Begin VB.Label lblValue 
         Height          =   255
         Left            =   3240
         TabIndex        =   8
         Top             =   480
         Width           =   735
      End
   End
   Begin VB.CommandButton cmdDisconnect 
      Caption         =   "Disconnect"
      Enabled         =   0   'False
      Height          =   375
      Left            =   3000
      TabIndex        =   3
      Top             =   480
      Width           =   1335
   End
   Begin VB.CommandButton cmdConnect 
      Caption         =   "Connect"
      Enabled         =   0   'False
      Height          =   375
      Left            =   1560
      TabIndex        =   2
      Top             =   480
      Width           =   1335
   End
   Begin VB.ComboBox cmbPoKeys55Devices 
      Enabled         =   0   'False
      Height          =   315
      Left            =   2400
      Style           =   2  'Dropdown List
      TabIndex        =   1
      Top             =   120
      Width           =   1935
   End
   Begin VB.Label lblSelectID 
      AutoSize        =   -1  'True
      Caption         =   "Select PoKeys55 UserID:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   238
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   195
      Left            =   120
      TabIndex        =   0
      Top             =   180
      Width           =   2160
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim PoKeys55Device As New PoKeysDevice_DLL.PoKeysDevice

Private Enum eFunctions
    no_function = 0
    digital_input = 2
    digital_output = 4
    analog_input = 8
    analog_output = 16
    invert_pin = 128
End Enum

Private outputState As Boolean

Private Sub chkInvertInput_Click()
    cmdSetInput_Click
End Sub

Private Sub chkInvertOutput_Click()
    cmdSetOutput_Click
End Sub

Private Sub cmdSetInput_Click()
    PoKeys55Device.SetPinData_2 43, eFunctions.analog_input
    
    tmrRefresh.Enabled = True
End Sub

Private Sub cmdSetOutput_Click()
    PoKeys55Device.SetPinData_2 42, eFunctions.analog_output
    hScrValue.Enabled = True
    lblOutValue.Caption = "0"
    hScrValue.Value = 0
    PoKeys55Device.SetAnalogOutputValue_2 42, 0
End Sub


Private Sub cmdConnect_Click()
    If PoKeys55Device.ConnectToDevice(cmbPoKeys55Devices.ListIndex) = True Then
        cmdConnect.Enabled = False
        cmdDisconnect.Enabled = True
        cmbPoKeys55Devices.Enabled = False
        frOperations.Enabled = True
    
        cmdSetInput.Enabled = True
        cmdSetOutput.Enabled = True
        hScrValue.Enabled = False
        picValue.Cls
        lblValue.Caption = ""
    End If
    
    Dim func As Byte
    
    For i = 0 To 54
        PoKeys55Device.GetPinData_2 i, func
        Debug.Print func
    Next
End Sub

Private Sub cmdDisconnect_Click()
    PoKeys55Device.DisconnectDevice
    cmdConnect.Enabled = True
    cmdDisconnect.Enabled = False
    cmbPoKeys55Devices.Enabled = True
    frOperations.Enabled = False
    
    cmdSetInput.Enabled = False
    cmdSetOutput.Enabled = False
    hScrValue.Enabled = False
    tmrRefresh.Enabled = False
End Sub

Private Sub Form_Load()
    Dim iDevices As Integer
    Dim i As Integer
    Dim userID As Byte
    
        
    iDevices = PoKeys55Device.EnumerateDevices()
    
    If iDevices = 0 Then
        cmbPoKeys55Devices.AddItem "no devices"
        Exit Sub
    End If
    
    For i = 0 To iDevices - 1
        PoKeys55Device.ConnectToDevice i
        PoKeys55Device.GetUserID userID
        PoKeys55Device.DisconnectDevice
        
        cmbPoKeys55Devices.AddItem "PoKeys55 - " & userID
    Next i
    
    cmbPoKeys55Devices.ListIndex = 0
    cmbPoKeys55Devices.Enabled = True
    cmdConnect.Enabled = True
    
    hScrValue.Enabled = False
End Sub

Private Sub Image1_Click()
    outputState = Not outputState
    
    PoKeys55Device.SetOutput 1, outputState
    
    shStateOutput.FillColor = IIf(outputState, vbGreen, vbBlack)
End Sub

Private Sub hScrValue_Change()
    PoKeys55Device.SetAnalogOutputValue_2 42, hScrValue.Value
    lblOutValue.Caption = hScrValue.Value
End Sub

Private Sub hScrValue_Scroll()
    PoKeys55Device.SetAnalogOutputValue_2 42, hScrValue.Value
    lblOutValue.Caption = hScrValue.Value
End Sub

Private Sub tmrRefresh_Timer()
    Dim analogValue As Long
    Dim boxWidth As Long
    
    PoKeys55Device.GetAnalogInput 43, analogValue
    
    lblValue.Caption = analogValue
        
    boxWidth = analogValue * picValue.Width / 1024
    
    picValue.Line (0, 0)-(boxWidth, picValue.Height), RGB(80, 150, 255), BF
    picValue.Line (boxWidth, 0)-(picValue.Width, picValue.Height), RGB(255, 255, 255), BF
    
    Debug.Print analogValue
End Sub
