﻿Module Module1

    Sub Main()

        Console.WriteLine("PoKeys56 Example 1 - device enumeration" & vbCrLf)

        ' Create PoKeys device object
        Dim device As New PoKeysDevice_DLL.PoKeysDevice

        Dim ipAddresses() As String
        Dim automaticDiscovery As Boolean = True
        Dim iNumDevices As Integer


        If automaticDiscovery Then
            ' Start automatic discovery of PoKeys56E devices
            device.StartEthernetDiscovery()

            ' Wait 1 second for discovery to gather results
            System.Threading.Thread.Sleep(1000)

            ' Stop automatic discovery
            device.StopEthernetDiscovery()

            ' Get the number of detected network devices
            iNumDevices = device.GetNumberOfDetectedNetworkDevices()

            Console.WriteLine(vbCrLf & "Found " & iNumDevices & " PoKeys56E devices")

            ipAddresses = device.GetNetworkDevicesAddressses()

        Else

            ' Connect to PoKeys56E device with a known IP (for example 192.168.10.101
            iNumDevices = 1
            ReDim ipAddresses(1)
            ipAddresses(0) = "192.168.10.101"

            ' You can also connect to the device directly... device.ConnectToNetworkDevice("192.168.10.101");
        End If

        Dim i As Integer

        ' Connect to every device and list data
        For i = 0 To iNumDevices - 1
            device.ConnectToNetworkDevice(ipAddresses(i))

            Dim userID As Byte = 0
            Dim serialNumber As Integer = 0
            Dim versionMajor As Integer = 0
            Dim versionMinor As Integer = 0

            device.GetUserID(userID)
            device.GetDeviceIDEx(serialNumber, versionMajor, versionMinor)

            Console.WriteLine("Device #" & i & ", UserID: " & userID & ", Serial number: " & serialNumber & _
                ", Version: " & (Int(versionMajor / 16) + 1) & "." & (versionMajor Mod 16) & "." & versionMinor)

            device.DisconnectDevice()
        Next i


        Console.WriteLine(vbCrLf & "Press any key to exit")
        Console.ReadKey()
    End Sub

End Module
