﻿Module Module1
    Enum pinFunctionsEnum
        pinFunctionInactive = 0
        pinFunctionDigitalInput = 2
        pinFunctionDigitalOutput = 4
        pinFunctionAnalogInput = 8
        pinFunctionAnalogOutput = 16
        pinInvert = 128
    End Enum

    ' Key modifiers
    Enum keyModifiers
        CtrlMask = 1
        ShiftMask = 2
        AltMask = 4
        WinMask = 8
        AltGrMask = 64
    End Enum


    ' Key codes
    Public Enum ekeyCodes
        key_a = &H4
        ' Shift combination: A
        key_b = &H5
        ' Shift combination: B
        key_c = &H6
        ' Shift combination: C
        key_d = &H7
        ' Shift combination: D
        key_e = &H8
        ' Shift combination: E
        key_f = &H9
        ' Shift combination: F
        key_g = &HA
        ' Shift combination: G
        key_h = &HB
        ' Shift combination: H
        key_i = &HC
        ' Shift combination: I
        key_j = &HD
        ' Shift combination: J
        key_k = &HE
        ' Shift combination: K
        key_l = &HF
        ' Shift combination: L
        key_m = &H10
        ' Shift combination: M
        key_n = &H11
        ' Shift combination: N
        key_o = &H12
        ' Shift combination: O
        key_p = &H13
        ' Shift combination: P
        key_q = &H14
        ' Shift combination: Q
        key_r = &H15
        ' Shift combination: R
        key_s = &H16
        ' Shift combination: S
        key_t = &H17
        ' Shift combination: T
        key_u = &H18
        ' Shift combination: U
        key_v = &H19
        ' Shift combination: V
        key_w = &H1A
        ' Shift combination: W
        key_x = &H1B
        ' Shift combination: X
        key_y = &H1C
        ' Shift combination: Y
        key_z = &H1D
        ' Shift combination: Z
        key_1 = &H1E
        ' Shift combination: !
        key_2 = &H1F
        ' Shift combination: @
        key_3 = &H20
        ' Shift combination: #
        key_4 = &H21
        ' Shift combination: $
        key_5 = &H22
        ' Shift combination: %
        key_6 = &H23
        ' Shift combination: ^
        key_7 = &H24
        ' Shift combination: &
        key_8 = &H25
        ' Shift combination: *
        key_9 = &H26
        ' Shift combination: (
        key_0 = &H27
        ' Shift combination: )
        key_Minus = &H2D
        ' Shift combination: _
        key_Equal = &H2E
        ' Shift combination: +
        key_SquareOpeningBracket = &H2F
        ' Shift combination: {
        key_SquareClosingBracket = &H30
        ' Shift combination: }
        key_BackSlash = &H31
        ' Shift combination: |
        key_Semicolon = &H33
        ' Shift combination: :
        key_Apostrophe = &H34
        ' Shift combination: 
        key_Tilde = &H35
        ' Shift combination: ~
        key_Comma = &H36
        ' Shift combination: <
        key_FullStop = &H37
        ' Shift combination: >
        key_Slash = &H38
        ' Shift combination: ?
        key_Return = &H28
        ' Shift combination: 
        key_Escape = &H29
        ' Shift combination: 
        key_Backspace = &H2A
        ' Shift combination: 
        key_Tab = &H2B
        ' Shift combination: 
        key_Space = &H2C
        ' Shift combination: 
        key_CapsLock = &H39
        ' Shift combination: 
        key_F1 = &H3A
        ' Shift combination: 
        key_F2 = &H3B
        ' Shift combination: 
        key_F3 = &H3C
        ' Shift combination: 
        key_F4 = &H3D
        ' Shift combination: 
        key_F5 = &H3E
        ' Shift combination: 
        key_F6 = &H3F
        ' Shift combination: 
        key_F7 = &H40
        ' Shift combination: 
        key_F8 = &H41
        ' Shift combination: 
        key_F9 = &H42
        ' Shift combination: 
        key_F10 = &H43
        ' Shift combination: 
        key_F11 = &H44
        ' Shift combination: 
        key_F12 = &H45
        ' Shift combination: 
        key_PrintScreen = &H46
        ' Shift combination: 
        key_ScrollLock = &H47
        ' Shift combination: 
        key_Insert = &H49
        ' Shift combination: 
        key_Home = &H4A
        ' Shift combination: 
        key_PageUp = &H4B
        ' Shift combination: 
        key_Delete = &H4C
        ' Shift combination: 
        key_End = &H4D
        ' Shift combination: 
        key_PageDown = &H4E
        ' Shift combination: 
        key_RightArrow = &H4F
        ' Shift combination: 
        key_LeftArrow = &H50
        ' Shift combination: 
        key_DownArrow = &H51
        ' Shift combination: 
        key_UpArrow = &H52
        ' Shift combination: 
        key_NumLock = &H53
        ' Shift combination: 
        key_KeypadDivide = &H54
        ' Shift combination: 
        key_KeypadMultiply = &H55
        ' Shift combination: 
        key_KeypadMinus = &H56
        ' Shift combination: 
        key_KeypadPlus = &H57
        ' Shift combination: 
        key_KeypadEnter = &H58
        ' Shift combination: 
        key_Keypad1 = &H59
        ' Shift combination: 
        key_Keypad2 = &H5A
        ' Shift combination: 
        key_Keypad3 = &H5B
        ' Shift combination: 
        key_Keypad4 = &H5C
        ' Shift combination: 
        key_Keypad5 = &H5D
        ' Shift combination: 
        key_Keypad6 = &H5E
        ' Shift combination: 
        key_Keypad7 = &H5F
        ' Shift combination: 
        key_Keypad8 = &H60
        ' Shift combination: 
        key_Keypad9 = &H61
        ' Shift combination: 
        key_Keypad0 = &H62
        ' Shift combination: 
        key_KeypadDot = &H63
        ' Shift combination: 
    End Enum



    Sub Main()
        Console.WriteLine("PoKeys55 Example 2 - basic pin functions" & vbCrLf)

        ' Create PoKeys55 device object
        Dim device As New PoKeysDevice_DLL.PoKeysDevice()

        ' Enumerate devices (this step must never be ommited!)
        Dim iNumDevices As Integer = device.EnumerateDevices()

        If iNumDevices = 0 Then
            Console.WriteLine("No PoKeys55 devices found!")


            Console.WriteLine(vbCrLf & "Press any key to exit")
            Console.ReadKey()
            Exit Sub

        End If


        ' Connect to first PoKeys55 device
        device.ConnectToDevice(0)


        ' Set pin 1 as digital input (pin 1 has pin index 0!)
        device.SetPinData(0, pinFunctionsEnum.pinFunctionDigitalInput)
        Console.WriteLine("Pin 1 was set as digital input")

        ' Set pin 2 as inverted digital input
        device.SetPinData(1, pinFunctionsEnum.pinFunctionDigitalInput + pinFunctionsEnum.pinInvert)
        Console.WriteLine("Pin 2 was set as inverted digital input")

        ' Set pin 3 as digital output
        device.SetPinData(2, pinFunctionsEnum.pinFunctionDigitalOutput)
        Console.WriteLine("Pin 3 was set as digital output")

        ' Set pin 4 as inverted digital output
        device.SetPinData(3, pinFunctionsEnum.pinFunctionDigitalOutput + pinFunctionsEnum.pinInvert)
        Console.WriteLine("Pin 4 was set as inverted digital output")

        ' Set pin 5 as digital input directly mapped to a key shift+A
        device.SetPinData(4, pinFunctionsEnum.pinFunctionDigitalInput + pinFunctionsEnum.pinInvert)
        device.SetPinKeyMapping(4, ekeyCodes.key_a, keyModifiers.ShiftMask)

        Console.WriteLine(vbCrLf & "Reading pin states:")

        Dim pinState As Boolean = False

        ' Get pin 1 state
        device.GetInput(0, pinState)
        Console.WriteLine("Pin 1: " & pinState.ToString())

        ' Get pin 2 state
        device.GetInput(1, pinState)
        Console.WriteLine("Pin 2: " & pinState.ToString())


        Console.WriteLine(vbCrLf & "Setting pin states:")

        ' Set pin 3 state to 1
        device.SetOutput(2, True)
        Console.WriteLine("Pin 3 set to 1")

        ' Set pin 4 state to 0
        device.SetOutput(3, False)
        Console.WriteLine("Pin 4 set to 0")

        ' Disconnect from device
        device.DisconnectDevice()

        Console.WriteLine(vbCrLf & "Press any key to exit")
        Console.ReadKey()
    End Sub

End Module
