﻿Module Module1

    Enum pinFunctionsEnum
        pinFunctionInactive = 0
        pinFunctionDigitalInput = 2
        pinFunctionDigitalOutput = 4
        pinFunctionAnalogInput = 8
        pinFunctionAnalogOutput = 16
        pinInvert = 128
    End Enum

    Sub Main()
        Console.WriteLine("PoKeys55 Example 2 - basic pin functions" & vbCrLf)

        ' Create PoKeys55 device object
        Dim device As New PoKeysDevice_DLL.PoKeysDevice()

        ' Enumerate devices (this step must never be ommited!)
        Dim iNumDevices As Integer = device.EnumerateDevices()

        If iNumDevices = 0 Then
            Console.WriteLine("No PoKeys55 devices found!")

            Console.WriteLine(vbCrLf & "Press any key to exit")
            Console.ReadKey()
            Exit Sub

        End If


        ' Connect to first PoKeys55 device
        device.ConnectToDevice(0)

        ' Set pin 43 as analog input
        device.SetPinData(42, pinFunctionsEnum.pinFunctionAnalogInput)
        Console.WriteLine("Pin 43 was set as analog input")


        Dim analogValue As Integer
        Dim analogInputVoltage As Double

        ' Get analog input value
        device.GetAnalogInput(CType(42, Byte), analogValue)

        analogInputVoltage = CType(analogValue, Double) / 1023 * 3.3 ' analogValue is 10-bit number, hence 1023 used
        Console.WriteLine(vbCrLf & "Current analog input voltage: " & analogInputVoltage.ToString("0.00") & " V")


        ' Disconnect from device
        device.DisconnectDevice()

        Console.WriteLine(vbCrLf & "Press any key to exit")
        Console.ReadKey()
    End Sub


End Module
