﻿Module Module1

    Enum pinFunctionsEnum
        pinFunctionInactive = 0
        pinFunctionDigitalInput = 2
        pinFunctionDigitalOutput = 4
        pinFunctionAnalogInput = 8
        pinFunctionAnalogOutput = 16
        pinInvert = 128
    End Enum

    Sub Main()
        Console.WriteLine("PoKeys55 Example 4 - analog output" & vbCrLf)

        ' Create PoKeys55 device object
        Dim device As New PoKeysDevice_DLL.PoKeysDevice()

        ' Enumerate devices (this step must never be ommited!)
        Dim iNumDevices As Integer = device.EnumerateDevices()

        If iNumDevices = 0 Then
            Console.WriteLine("No PoKeys55 devices found!")

            Console.WriteLine(vbCrLf & "Press any key to exit")
            Console.ReadKey()
            Exit Sub

        End If


        ' Connect to first PoKeys55 device
        device.ConnectToDevice(0)


        ' Set pin 43 as analog output
        device.SetPinData(42, pinFunctionsEnum.pinFunctionAnalogOutput)
        Console.WriteLine("Pin 43 was set as analog output")


        Dim analogOutputVoltage As Double = 2 '2.00 V

        'Set analog output value
        device.SetAnalogOutputValue(CType(42, Byte), CType(analogOutputVoltage / 3.3 * 1023, Integer))
        Console.WriteLine(vbCrLf & "Analog output voltage set to " & analogOutputVoltage.ToString("0.00") & " V")


        ' Disconnect from device
        device.DisconnectDevice()

        Console.WriteLine(vbCrLf & "Press any key to exit")
        Console.ReadKey()
    End Sub


End Module
