﻿Module Module1



    Sub Main()
        Console.WriteLine("PoKeys55 Example 2 - basic pin functions" & vbCrLf)

        ' Create PoKeys55 device object
        Dim device As New PoKeysDevice_DLL.PoKeysDevice()

        ' Enumerate devices (this step must never be ommited!)
        Dim iNumDevices As Integer = device.EnumerateDevices()

        If iNumDevices = 0 Then
            Console.WriteLine("No PoKeys55 devices found!")

            Console.WriteLine(vbCrLf & "Press any key to exit")
            Console.ReadKey()
            Exit Sub

        End If


        ' Connect to first PoKeys55 device
        device.ConnectToDevice(0)


        ' All PWM channels share the same PWM frequency, set by period value
        ' PoKeys55 PWM base frequency is 12 MHz = 12 000 000 ticks per second
        ' PoKeys56 PWM base frequency is 25 MHz = 25 000 000 ticks per second
        ' The PWM frequency of the device, currently in use can be obtained with the function GetPWMFrequency()
        ' To produce 1 kHz PWM frequency, period must be set to 12000 or 25000 (this equals to 1 milisecond)
        ' Duty cycle is a number of ticks inside period for which output will be high
        '
        '        |...............|                                               |........... 
        '        |               |                                               |
        ' .......|               |...............................................|
        '        0           duty cycle                                       period
        '                                                                        0
        ' PWM uses special outputs mapping:
        ' PWM output 0: Pin 22
        ' PWM output 1: Pin 21
        ' PWM output 2: Pin 20
        ' PWM output 3: Pin 19
        ' PWM output 4: Pin 18
        ' PWM output 5: Pin 17

        Dim output(5) As Boolean

        ' Activate pins 17 and 18 (outputs 5 and 4)
        output(5) = True
        output(4) = True
        output(3) = False
        output(2) = False
        output(1) = False
        output(0) = False

        ' Set period to 1 ms to produce 1 kHz PWM
        Dim period As UInteger = device.GetPWMFrequency() / 1000

        Dim duty(5) As UInteger

        ' Set duty cycle for pin 17 to 50% by setting it to half of the period
        duty(5) = period * 0.5

        ' Set duty cycle for pin 18 to 10% by setting it to 1/10 of the period
        duty(4) = period * 0.1

        ' Send settings to device
        device.SetPWMOutputs(output, period, duty)
        Console.WriteLine("PWM with frequency of 1 kHz on pins 17 and 18 is activated")


        ' Disconnect from device
        device.DisconnectDevice()

        Console.WriteLine(vbCrLf & "Press any key to exit")
        Console.ReadKey()
    End Sub


End Module
