﻿Module Module1

    Sub Main()
        Console.WriteLine("PoKeys55 Example 8 - matrix LED usage" & vbLf)

        ' Create PoKeys55 device object
        Dim device As New PoKeysDevice_DLL.PoKeysDevice()

        ' Enumerate devices (this step must never be ommited!)
        Dim iNumDevices As Integer = device.EnumerateDevices()

        If iNumDevices = 0 Then
            Console.WriteLine("No PoKeys55 devices found!")


            Console.WriteLine(vbLf & "Press any key to exit")
            Console.ReadKey()
            Exit Sub
        End If

        ' Connect to first PoKeys55 device
        device.ConnectToDevice(0)


        ' Connect matrix LED display accordingly to the schematics found in PoKeys55 user manual
        ' Use this pin mapping:
        '   - pin 9 as serial data
        '   - pin 10 as shift register latch clock
        '   - pin 11 as serial clock

        ' Use only display 1
        device.MatrixLEDSetSettings(True, 5, 5, False, 0, 0)

        ' Fill the display pixel by pixel
        device.MatrixLED1ClearAll(False)

        For y As Byte = 0 To 4
            For x As Byte = 0 To 4
                device.MatrixLED1SetPixel(y, x, True)

                System.Threading.Thread.Sleep(20)
            Next
        Next

        ' Then clear the whole display pixel by pixel
        For y As Byte = 0 To 4
            For x As Byte = 0 To 4
                device.MatrixLED1SetPixel(y, x, False)

                System.Threading.Thread.Sleep(20)
            Next
        Next

        ' Update display with some data (increasing bars)
        ' these bytes are pixel mapped
        ' displayBuffer[0].0 (first bit in first byte) represents first pixel on the display
        Dim displayBuffer As Byte() = New Byte(7) {}
        displayBuffer(0) = 1
        displayBuffer(1) = 3
        displayBuffer(2) = 7
        displayBuffer(3) = 15
        displayBuffer(4) = 31
        displayBuffer(5) = 0
        displayBuffer(6) = 0
        displayBuffer(7) = 0

        device.MatrixLED1Update(displayBuffer)


        device.DisconnectDevice()

        Console.WriteLine(vbLf & "Press any key to exit")
        Console.ReadKey()
    End Sub

End Module
