﻿Module Module1

    ' Pin functions
    Public Enum pinFunctionsEnum
        pinFunctionInactive = 0
        pinFunctionDigitalInput = 2
        pinFunctionDigitalOutput = 4
        pinFunctionAnalogInput = 8
        pinFunctionAnalogOutput = 16
        pinInvert = 128
    End Enum

    ' Key modifiers
    Public Enum ekeyModifiers
        CtrlMask = 1
        ShiftMask = 2
        AltMask = 4
        WinMask = 8
        AltGrMask = 64
    End Enum

    ' Key codes
    Public Enum ekeyCodes
        key_a = &H4
        ' Shift combination: A
        key_b = &H5
        ' Shift combination: B
        key_c = &H6
        ' Shift combination: C
        key_d = &H7
        ' Shift combination: D
        key_e = &H8
        ' Shift combination: E
        key_f = &H9
        ' Shift combination: F
        key_g = &HA
        ' Shift combination: G
        key_h = &HB
        ' Shift combination: H
        key_i = &HC
        ' Shift combination: I
        key_j = &HD
        ' Shift combination: J
        key_k = &HE
        ' Shift combination: K
        key_l = &HF
        ' Shift combination: L
        key_m = &H10
        ' Shift combination: M
        key_n = &H11
        ' Shift combination: N
        key_o = &H12
        ' Shift combination: O
        key_p = &H13
        ' Shift combination: P
        key_q = &H14
        ' Shift combination: Q
        key_r = &H15
        ' Shift combination: R
        key_s = &H16
        ' Shift combination: S
        key_t = &H17
        ' Shift combination: T
        key_u = &H18
        ' Shift combination: U
        key_v = &H19
        ' Shift combination: V
        key_w = &H1A
        ' Shift combination: W
        key_x = &H1B
        ' Shift combination: X
        key_y = &H1C
        ' Shift combination: Y
        key_z = &H1D
        ' Shift combination: Z
        key_1 = &H1E
        ' Shift combination: !
        key_2 = &H1F
        ' Shift combination: @
        key_3 = &H20
        ' Shift combination: #
        key_4 = &H21
        ' Shift combination: $
        key_5 = &H22
        ' Shift combination: %
        key_6 = &H23
        ' Shift combination: ^
        key_7 = &H24
        ' Shift combination: &
        key_8 = &H25
        ' Shift combination: *
        key_9 = &H26
        ' Shift combination: (
        key_0 = &H27
        ' Shift combination: )
        key_Minus = &H2D
        ' Shift combination: _
        key_Equal = &H2E
        ' Shift combination: +
        key_SquareOpeningBracket = &H2F
        ' Shift combination: {
        key_SquareClosingBracket = &H30
        ' Shift combination: }
        key_BackSlash = &H31
        ' Shift combination: |
        key_Semicolon = &H33
        ' Shift combination: :
        key_Apostrophe = &H34
        ' Shift combination: 
        key_Tilde = &H35
        ' Shift combination: ~
        key_Comma = &H36
        ' Shift combination: <
        key_FullStop = &H37
        ' Shift combination: >
        key_Slash = &H38
        ' Shift combination: ?
        key_Return = &H28
        ' Shift combination: 
        key_Escape = &H29
        ' Shift combination: 
        key_Backspace = &H2A
        ' Shift combination: 
        key_Tab = &H2B
        ' Shift combination: 
        key_Space = &H2C
        ' Shift combination: 
        key_CapsLock = &H39
        ' Shift combination: 
        key_F1 = &H3A
        ' Shift combination: 
        key_F2 = &H3B
        ' Shift combination: 
        key_F3 = &H3C
        ' Shift combination: 
        key_F4 = &H3D
        ' Shift combination: 
        key_F5 = &H3E
        ' Shift combination: 
        key_F6 = &H3F
        ' Shift combination: 
        key_F7 = &H40
        ' Shift combination: 
        key_F8 = &H41
        ' Shift combination: 
        key_F9 = &H42
        ' Shift combination: 
        key_F10 = &H43
        ' Shift combination: 
        key_F11 = &H44
        ' Shift combination: 
        key_F12 = &H45
        ' Shift combination: 
        key_PrintScreen = &H46
        ' Shift combination: 
        key_ScrollLock = &H47
        ' Shift combination: 
        key_Insert = &H49
        ' Shift combination: 
        key_Home = &H4A
        ' Shift combination: 
        key_PageUp = &H4B
        ' Shift combination: 
        key_Delete = &H4C
        ' Shift combination: 
        key_End = &H4D
        ' Shift combination: 
        key_PageDown = &H4E
        ' Shift combination: 
        key_RightArrow = &H4F
        ' Shift combination: 
        key_LeftArrow = &H50
        ' Shift combination: 
        key_DownArrow = &H51
        ' Shift combination: 
        key_UpArrow = &H52
        ' Shift combination: 
        key_NumLock = &H53
        ' Shift combination: 
        key_KeypadDivide = &H54
        ' Shift combination: 
        key_KeypadMultiply = &H55
        ' Shift combination: 
        key_KeypadMinus = &H56
        ' Shift combination: 
        key_KeypadPlus = &H57
        ' Shift combination: 
        key_KeypadEnter = &H58
        ' Shift combination: 
        key_Keypad1 = &H59
        ' Shift combination: 
        key_Keypad2 = &H5A
        ' Shift combination: 
        key_Keypad3 = &H5B
        ' Shift combination: 
        key_Keypad4 = &H5C
        ' Shift combination: 
        key_Keypad5 = &H5D
        ' Shift combination: 
        key_Keypad6 = &H5E
        ' Shift combination: 
        key_Keypad7 = &H5F
        ' Shift combination: 
        key_Keypad8 = &H60
        ' Shift combination: 
        key_Keypad9 = &H61
        ' Shift combination: 
        key_Keypad0 = &H62
        ' Shift combination: 
        key_KeypadDot = &H63
        ' Shift combination: 
    End Enum


    Sub Main()
        Console.WriteLine("PoKeys55 Example 9 - matrix keyboard usage" & vbLf)

        ' Create PoKeys55 device object
        Dim device As New PoKeysDevice_DLL.PoKeysDevice()

        ' Enumerate devices (this step must never be ommited!)
        Dim iNumDevices As Integer = device.EnumerateDevices()

        If iNumDevices = 0 Then
            Console.WriteLine("No PoKeys55 devices found!")


            Console.WriteLine(vbLf & "Press any key to exit")
            Console.ReadKey()
            Exit Sub
        End If

        ' Connect to first PoKeys55 device
        device.ConnectToDevice(0)

        Dim matrixKeyboardSetting As Byte = 1
        ' enabled
        Dim rows As Byte = 4
        ' 4 rows
        Dim cols As Byte = 4
        ' 4 columns
        Dim row_pins As Byte() = New Byte(15) {}
        ' row pins
        Dim col_pins As Byte() = New Byte(7) {}
        ' column pins
        Dim macro_mapping As Boolean() = New Boolean(127) {}
        Dim key_codes As Byte() = New Byte(127) {}
        Dim key_modifiers As Byte() = New Byte(127) {}

        ' Set remaining pins to FF
        For i As Integer = 0 To 7
            row_pins(i) = &HFF
            col_pins(i) = &HFF
        Next

        ' PoKeys55 pins 1 to 4 as matrix keyboard columns (digital inputs)
        col_pins(0) = 0
        col_pins(1) = 1
        col_pins(2) = 2
        col_pins(3) = 3

        device.SetPinData(0, CByte(pinFunctionsEnum.pinFunctionDigitalInput))
        device.SetPinData(1, CByte(pinFunctionsEnum.pinFunctionDigitalInput))
        device.SetPinData(2, CByte(pinFunctionsEnum.pinFunctionDigitalInput))
        device.SetPinData(3, CByte(pinFunctionsEnum.pinFunctionDigitalInput))

        ' PoKeys55 pins 5 to 8 as matrix keyboard rows (digital outputs)
        row_pins(0) = 4
        row_pins(1) = 5
        row_pins(2) = 6
        row_pins(3) = 7

        device.SetPinData(4, CByte(pinFunctionsEnum.pinFunctionDigitalOutput))
        device.SetPinData(5, CByte(pinFunctionsEnum.pinFunctionDigitalOutput))
        device.SetPinData(6, CByte(pinFunctionsEnum.pinFunctionDigitalOutput))
        device.SetPinData(7, CByte(pinFunctionsEnum.pinFunctionDigitalOutput))

        ' Use standard 4x4 matrix keyboard mapping
        key_codes(0) = CByte(ekeyCodes.key_1)
        key_codes(1) = CByte(ekeyCodes.key_2)
        key_codes(2) = CByte(ekeyCodes.key_3)
        key_codes(3) = CByte(ekeyCodes.key_a)

        key_codes(8) = CByte(ekeyCodes.key_4)
        key_codes(9) = CByte(ekeyCodes.key_5)
        key_codes(10) = CByte(ekeyCodes.key_6)
        key_codes(11) = CByte(ekeyCodes.key_b)

        key_codes(16) = CByte(ekeyCodes.key_7)
        key_codes(17) = CByte(ekeyCodes.key_8)
        key_codes(18) = CByte(ekeyCodes.key_9)
        key_codes(19) = CByte(ekeyCodes.key_c)

        key_codes(24) = CByte(ekeyCodes.key_KeypadMultiply)
        key_codes(25) = CByte(ekeyCodes.key_0)
        key_codes(26) = CByte(ekeyCodes.key_3)
        key_codes(27) = CByte(ekeyCodes.key_d)

        key_modifiers(26) = CByte(ekeyModifiers.ShiftMask)

        device.SetMatrixKeyboardConfiguration(matrixKeyboardSetting, cols, rows, row_pins, col_pins, macro_mapping, _
         key_codes, key_modifiers)

        Console.WriteLine("Matrix keyboard configured as standard 4x4")

        device.DisconnectDevice()

        Console.WriteLine(vbLf & "Press any key to exit")
        Console.ReadKey()
    End Sub

End Module
