﻿Public Class Form1
    Dim myDevice As New PoKeysDevice_DLL.PoKeysDevice

    Private Sub cmdConnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdConnect.Click
        If myDevice.Connected Then
            myDevice.DisconnectDevice()
        End If

        If myDevice.EnumerateDevices() = 0 Then
            MessageBox.Show("No PoKeys devices found!")
            lblStatus.Text = "No devices found"
            Return
        End If

        If myDevice.ConnectToDevice(0) Then
            lblStatus.Text = "Connected to PoKeys"
            cmdConnect.Enabled = False
            cmdOutput.Enabled = True
            cmdBlockSet.Enabled = True
            cmdSetPWM.Enabled = True
            cmdDisconnect.Enabled = True
        Else
            lblStatus.Text = "Error connecting to PoKeys!"
        End If
    End Sub

    Private Sub cmdDisconnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdDisconnect.Click
        If myDevice.Connected Then
            myDevice.DisconnectDevice()
            lblStatus.Text = "Disconnected"
            cmdConnect.Enabled = True
            cmdOutput.Enabled = False
            cmdBlockSet.Enabled = False
            cmdSetPWM.Enabled = False
            cmdDisconnect.Enabled = False
        End If
    End Sub

    Private Sub cmdOutput_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdOutput.Click
        myDevice.SetPinData(0, PoKeysDevice_DLL.ePinCap.digitalOutput)
        myDevice.SetOutput(0, True)

        Threading.Thread.Sleep(500)
        myDevice.SetOutput(0, False)
    End Sub

    Private Sub cmdSetPWM_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSetPWM.Click

        ' In Visual Basic, the upper index of the array is given in the brackets
        Dim output(5) As Boolean

        ' Activate pins 17 and 18 (outputs 5 and 4)
        output(5) = True
        output(4) = True
        output(3) = False
        output(2) = False
        output(1) = False
        output(0) = False

        ' Set period to 1 ms to produce 1 kHz PWM
        Dim period As UInteger = myDevice.GetPWMFrequency() / 1000

        Dim duty(5) As UInteger

        ' Set duty cycle for pin 17 to 50% by setting it to half of the period
        duty(5) = period * 0.5

        ' Set duty cycle for pin 18 to 10% by setting it to 1/10 of the period
        duty(4) = period * 0.1

        ' Send settings to device
        myDevice.SetPWMOutputs(output, period, duty)
    End Sub

    Private Sub cmdBlockSet_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdBlockSet.Click
        ' BlockSetOutputAll55 has an inverted function (back-compatibility issue...)
        Dim outputs(54) As Boolean

        outputs(0) = False ' set output to 1
        outputs(1) = True  ' set output to 0
        '...
        outputs(54) = False ' set output to 1

        myDevice.BlockSetOutputAll55(outputs) ' Takes 2 communication cycles to execute
    End Sub
End Class
